;PVdBDownPageCurl.ahk 
;AutoHotKey script for Personal Video Database download page to file UTF-8 NO BOM:
;   First argument A_Args[1]= URL
;   Second argument A_Args[2]= TargetFile
;   Third argument A_Args[3]= If present shows the script variables
;   If exists 'PVdBDownPage.log' write variables in this file
;CHANGE LOG:
;   V.2018.08.06-VVV_Easy: Added proxy suport if apears in "pvdconf.ini"
;   V.2018.05.31-VVV_Easy: Wait download all page before exit.ScriptLog subrutine
;   V.2018.05.30-VVV_Easy: Corrected bug with spaces in script path
;   V.2018.05.08-VVV_Easy: Detetecs Win OS version an use curl.exe if no Win10.
;   V.2018.05.06-VVV_Easy: Add log funtion in 'PVdBDownPage.log'.
;   V.2018.05.05-VVV_Easy: First version.
;------------------------------------------------------------
;Script behavior :
;   1) Hides the windows and runs in background
;   2) Encode the URL in escaped %Hexadecimal codes (for instance Space=%20)
;   3) Deletes the target file
;   4) Download the page in a UTF-8 NO BOM text file
;------------------------------------------------------------
;Compilation orders
    #NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
    #Warn  ; Enable warnings to assist with detecting common errors.
    #SingleInstance On  ;The word OFF allows multiple instances of the script to run concurrently
    ;#NoTrayIcon ;Disables the showing of a tray icon.
;Script behavior and Global variables
    DebugForceCURL:=0 ; Debug variable in order to force curl use in Win10 enviroment.
    Global ScriptName 
    SplitPath, A_ScriptName,,,, ScriptName ;Get ScriptName for windows title and log file.
    ;SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
    Global s_LogFile:= A_ScriptDir . "\PVdBDownPage.log"
    ;If not needed arguments show help
    If A_Args.Length()<2 { 
        MsgBox, 16, % ScriptName, % ScriptName ":`nAutoHotKey script for Personal Video Database download page to file UTF-8 NO BOM.`n`nUsage:`nFirst argument = URL`nSecond argument = TargetFile`nThird argument = If present shows the script variables`n`nIf exists 'PVdBDownPage.log', write variables in this file`n"
        ExitApp
    }
    WinHide, %A_ScriptFullPath%
    WinHide, %A_ScriptName%
    Global EscapedURL:=url_encode(A_Args[1])
    StringReplace, EscapedURL, EscapedURL, `", / , All ;If the URL finish in / provoques a escape quote. See https://www.autohotkey.com/docs/Scripts.htm#cmd
    ;Get proxi parameters from "pvdconf.ini"
    PVDProxy:=""    
    FileRead, PVDConfig, % StrReplace(A_ScriptDir,"\Scripts" ,"") . "\pvdconf.ini" ; The repetition of "\" is for allow debug with not "Scripts" folder. Notice that there isn't file comprobation
    PVDUseProxy:=SubStr(PVDConfig,StrLen("UseProxy=")+InStr(PVDConfig,"UseProxy="),InStr(PVDConfig,"`r`n",,1+StrLen("UseProxy=")+InStr(PVDConfig,"UseProxy="))-(StrLen("UseProxy=")+InStr(PVDConfig,"UseProxy=")))
    If (PVDUseProxy=1) {
        PVDProxyServer:=SubStr(PVDConfig,StrLen("ProxyServer=")+InStr(PVDConfig,"ProxyServer="),InStr(PVDConfig,"`r`n",,1+StrLen("ProxyServer=")+InStr(PVDConfig,"ProxyServer="))-(StrLen("ProxyServer=")+InStr(PVDConfig,"ProxyServer=")))
        PVDProxyPort:=SubStr(PVDConfig,StrLen("ProxyPort=")+InStr(PVDConfig,"ProxyPort="),InStr(PVDConfig,"`r`n",,1+StrLen("ProxyPort=")+InStr(PVDConfig,"ProxyPort="))-(StrLen("ProxyPort=")+InStr(PVDConfig,"ProxyPort=")))
        PVDProxyUser:=SubStr(PVDConfig,StrLen("ProxyUserName=")+InStr(PVDConfig,"ProxyUserName="),InStr(PVDConfig,"`r`n",,1+StrLen("ProxyUserName=")+InStr(PVDConfig,"ProxyUserName="))-(StrLen("ProxyUserName=")+InStr(PVDConfig,"ProxyUserName=")))
        PVDProxyPass:=SubStr(PVDConfig,StrLen("ProxyPassword=")+InStr(PVDConfig,"ProxyPassword="),InStr(PVDConfig,"`r`n",,1+StrLen("ProxyPassword=")+InStr(PVDConfig,"ProxyPassword="))-(StrLen("ProxyPassword=")+InStr(PVDConfig,"ProxyPassword=")))            
        PVDProxy:="http://" . PVDProxyUser . ":" . PVDProxyPass . "@" . PVDProxyServer . ":" . PVDProxyPort
    }
    ;Show variables with debug third parameter
    If A_Args.Length()>2
        MsgBox, 64, % ScriptName, % ScriptName " variables:`n`nNumber of parameters = " A_Args.Length() "`nURL =|" A_Args[1] "|`nFile =|" A_Args[2] "|`nPVDUseProxy =|" PVDUseProxy "|`nPVDProxy =|" PVDProxy "|`n`nEscapedURL =|" EscapedURL "|`nWinVersion =|" A_OSVersion "|`nDebugForceCURL =|" DebugForceCURL "| `n"
    ;If exists, write variables in the log file
    ScriptLog( A_Now "-" ScriptName " variables:`n`tNumber arguments = " A_Args.Length() "`n`t       URL=|" A_Args[1] "|`n`tEscapedURL=|" EscapedURL "|`n`tFile=|" A_Args[2] "|`n", 0)
    If FileExist(A_Args[2] . ".tmp")
        FileDelete, % A_Args[2] . ".tmp"
    If (Not DebugForceCURL and (A_OSVersion < "W" && A_OSVersion >= "10."))  { ;Use the own download function in Win10=10.0.14393 but always requires Windows 2000/XP or later (because "0".."9" < "W").
                                                    ; Autohotkey doesn't support WIN_NT4,WIN_95,WIN_98,WIN_ME, https://en.wikipedia.org/wiki/Comparison_of_Microsoft_Windows_versions
            ScriptLog( A_Now "-" ScriptName " WinVersion=|" A_OSVersion "|`tDownload with AutoHotkey.`n", 0)
        Download(EscapedURL,A_Args[2] . ".tmp",True,{"User-Agent": "Mozilla/5.0 (Windows NT 6.3; WOW64; rv:37.0) Gecko/20100101 Firefox/37.0", "Cache-Control": "max-age=0"},,,PVDProxy)
    } else {  ;Use curl.exe for download (for TLS 1.2 in Win7) . Not page redirection managed. -A=Append -L=Location (allow redirection) -s=silent -o=output(for file)
        If StrLen(PVDProxy)>0 {
            ProxyUserPass:=SubStr(PVDProxy,2+InStr(PVDProxy,"//"),InStr(PVDProxy,"@")-(2+InStr(PVDProxy,"//"))) ;USERNAME:PASSWORD
            ProxyDirPort:=StrReplace(PVDProxy,ProxyUserPass . "@","")
            RunSentence:= """" . A_ScriptDir . "\curl.exe" . """" . "-x " . ProxyDirPort . " -U " . ProxyUserPass . " -A ""Mozilla/5.0 (Windows NT 6.1; Trident/7.0; rv:11.0) like Gecko"" -L -s -o """ . A_Args[2] . ".tmp" . """ " . EscapedURL
        } else { ;No proxy   
            RunSentence:= """" . A_ScriptDir . "\curl.exe" . """" . "-A ""Mozilla/5.0 (Windows NT 6.1; Trident/7.0; rv:11.0) like Gecko"" -L -s -o """ . A_Args[2] . ".tmp" . """ " . EscapedURL 
        }
        ;MsgBox, 64, % ScriptName, % RunSentence
        ScriptLog( A_Now "-" ScriptName " WinVersion=|" A_OSVersion "|`tDownload with:`n`t`t|" RunSentence "|`n", 0)
        Run, % RunSentence , A_ScriptDir , hide
    }
    ;Wait download finish and exist the downloaded page.
    ScriptLog( A_Now "- Waiting file exist of downloaded page:" . A_Args[2] . ".tmp" . "|`n", 1)
    While ( Not FileExist( A_Args[2] . ".tmp" ) ) {
        If (A_Index > 10) { ;10 seconds maximum (if not Internet)
            ScriptLog( A_Now "- " . A_Index . " More than 10 second waiting download. Not Internet connection?: ExitApp|`n", 2)
            ExitApp
        }
        ScriptLog( A_Now "- " . A_Index . " Waiting 1s for exists of: " . A_Args[2] . ".tmp" . "|`n", 2)
        Sleep, 1000
    }
    ;Wait download finish of downloaded page.
    FileGetSize, DownLoadSize1, % A_Args[2] . ".tmp"
    ScriptLog( A_Now "- Waiting finish of download. Size of: " . A_Args[2] . ".tmp" . " is " . DownLoadSize1 . "|" . ErrorLevel . "|`n", 1)
    Sleep, 1000
    FileGetSize, DownLoadSize2, % A_Args[2] . ".tmp"
    While ( Not (DownLoadSize2=DownLoadSize1) ) {
        If (A_Index > 10) { ;10 seconds maximum (if not Internet)
            ScriptLog( A_Now "- " . A_Index . " More than 10 second waiting download. Cut of Internet connection?: ExitApp|`n", 2)
            ExitApp
        }
        ScriptLog( A_Now "- " . A_Index . " Waiting 1s finish of download. Size of: " . A_Args[2] . ".tmp" . " is " . DownLoadSize2 . "|" . ErrorLevel . "|`n", 2)
        Sleep, 1000
        DownLoadSize1:=DownLoadSize2
        FileGetSize, DownLoadSize2, % A_Args[2] . ".tmp"
    }
    ScriptLog( A_Now "- Finish download. Size of: " . A_Args[2] . ".tmp" . " is " . DownLoadSize2 . "|" . ErrorLevel . "|`n", 1)
    FileMove, % A_Args[2] . ".tmp", % A_Args[2], 1
    ExitApp
;SUBRUTINES--------------------------------------------------
ScriptLog(_s_Log, _i_TabDeep=0){ ; If exists, log in file global s_LogFile the messages of script. No Return value.
	If Not FileExist(s_LogFile)
        Return
    try{  ;Asegurate global s_LogFile access
		While (A_Index <= _i_TabDeep) ; Index with tab and | the message
			_s_Log:= % "`t|" . _s_Log
		;With user validation screen output
			;MsgBox, 64, % A_ScriptName . "-" . A_ThisFunc . "-(" . A_LineNumber . ")" ,%_s_Log%   ;Debug
		;Fast screen output (no scroll)
			;ToolTip, %_s_Log% ;, 5, 300
		;Log to file
		FileAppend %_s_Log%, %s_LogFile%
	}
	catch e {
        MsgBox 16, % ScriptName "-" A_ThisFunc "-(" A_LineNumber ") ", % "Error catched at line " e.Line " in |" e.What "|:`n" e.Message "`nin: |" s_LogFile "|"
        ExitApp            
    }		
	Return
}
;AutoHotKey Snipets------------------------------------------------------------------------
url_encode(str){ ; encode the special characters of a UTF-8 string in a string. Some chars (-._~:/?#@!$&()[]*+=,;%) are omited because are reserved for url in the RFC 1738 specification.
    ; https://autohotkey.com/board/topic/17367-url-encoding-and-decoding-of-special-characters/#entry501592
    ;Usage-> URL:=fn_encode(string); string:=fn_decode(URL)
    ;Documentation: Characters allowed in a URL https://stackoverflow.com/questions/1856785/characters-allowed-in-a-url
    ;   IPv4address = dec-octet "." dec-octet "." dec-octet "." dec-octet
    ;   dec-octet   = DIGIT                 ; 0-9
    ;          / %x31-39 DIGIT         ; 10-99
    ;          / "1" 2DIGIT            ; 100-199
    ;          / "2" %x30-34 DIGIT     ; 200-249
    ;          / "25" %x30-35          ; 250-255
    ;   reg-name    = *( unreserved / pct-encoded / sub-delims )
    ;       unreserved  = ALPHA / DIGIT / "-" / "." / "_" / "~"     <---This seems like a practical shortcut, most closely resembling original answer
    ;       reserved    = gen-delims / sub-delims
    ;       gen-delims  = ":" / "/" / "?" / "#" / "[" / "]" / "@"
    ;       sub-delims  = "!" / "$" / "&" / "'" / "(" / ")"
    ;                     / "*" / "+" / "," / ";" / "="
    ;       pct-encoded = "%" HEXDIG HEXDIG
   f = %A_FormatInteger%
   SetFormat, Integer, Hex   ; set integer format to hex
   
   If RegExMatch(str, "^\w+:/{0,2}", pr)   
      StringTrimLeft, str, str, StrLen(pr)
   
   ;StringReplace, str, str, `%, `%25, All    ; replace all % with %25 -> Bad for some url with decoded chars
   
   Loop
      If RegExMatch(str, "i)[^\w\-._~:/?#@!$&()\[\]*+=,;%]", char)    ; exclude alphnumeric -._~:/?#@!$&()[]*+=,;%
         StringReplace, str, str, %char%, % "%" . fn_zerofill(SubStr(Asc(char),3),2) , All
      Else Break
   
   SetFormat, Integer, %f%   ; restore integer format
   Return, pr . str
}
url_decode(str){
    Loop
        If RegExMatch(str, "i)(?<=%)[\da-f]{1,2}", hex)
            StringReplace, str, str, `%%hex%, % Chr("0x" . hex), All
        Else Break
    Return, str
}
fn_zerofill(num, size){   ; returns num zerofilled to size digits ; example call to zerofill -> n := zerofill(n, 3)
    StringLen, length, num
    c := size - length 
    loop, %c%
        num := "0" num
    return num
}
;==========================================================================================
Download(UrlToFile,SaveFileAs:="",Overwrite:=True,headers:="",method:="GET",postData:="",ProxyData:="") { ; https://stackoverflow.com/questions/29460945/alternative-to-urldownloadtofile      ;https://docs.microsoft.com/en-us/windows/desktop/winhttp/winhttprequest
    ; ProxyData parameter type UNIX: "http://USERNAME:PASSWORD@proxy-server.mycorp.com:port" (not syntax verification)
    ;Examples:
    ;   1)    Download("http://ahkscript.org/download/1.1/AutoHotkey111402_Install.exe")
    ;   2)    customHeaders := {"User-Agent": "Mozilla/5.0 (Windows NT 6.3; WOW64; rv:37.0) Gecko/20100101 Firefox/37.0", "Cache-Control": "max-age=0", "Cookie": "downloadtoken=b82416fdb23e421fb5a"}
    ;         Download("http://download.piriform.com/ccsetup410.exe","",True,customHeaders)
    ;   3)    Download("http://foo.bar/example.exe","example.exe",True,{"Cookie":"sessionid=abc123"},"POST","username=foo_bar&password=qwerty")
    ;
    WinHttpObj := ComObjCreate("WinHttp.WinHttpRequest.5.1")
    try { ;Script fails in not good url
        WinHttpObj.Open(method, UrlToFile)
        If StrLen(ProxyData)>0 {
            ProxyUsername:=SubStr(ProxyData,2+InStr(ProxyData,"//"),InStr(ProxyData,"@")-(2+InStr(ProxyData,"//"))) ;USERNAME:PASSWORD
            ProxyDirection:=StrReplace(ProxyData,ProxyUsername . "@","")
            ProxyPassword:=SubStr(ProxyUsername,1+InStr(ProxyUsername,":"),1+StrLen(ProxyUsername)-(1+InStr(ProxyUsername,":")))
            ProxyUsername:=StrReplace(ProxyUsername,":" . ProxyPassword,"")
            WinHttpObj.SetCredentials(ProxyUsername,ProxyPassword,1) ;HTTPREQUEST_SETCREDENTIALS_FOR_PROXY = 1;
            WinHttpObj.SetProxy(2,ProxyDirection) ;HTTPREQUEST_PROXYSETTING_PROXY = 2;
        }    
        ;WinHttpObj.SetTimeouts(6000,6000,6000,6000) ;Set timeouts to 6 seconds        
        
        For header, value in headers 
            WinHttpObj.SetRequestHeader(header, value)
    
        WinHttpObj.Send(postData)

        ADODBObj := ComObjCreate("ADODB.Stream")
        ADODBObj.Type := 1
        ADODBObj.Open()
        ADODBObj.Write(WinHttpObj.ResponseBody)
        If !SaveFileAs {
            urlSplitArray := StrSplit(UrlToFile, "/")
            SaveFileAs := urlSplitArray[urlSplitArray.MaxIndex()]
        }        
        ADODBObj.SaveToFile(SaveFileAs, Overwrite ? 2:1)
        ADODBObj.Close()
    }
    catch ed1 {
        ScriptLog( A_Now "-" ScriptName "-" A_ThisFunc "-(" A_LineNumber ") " "Error catched at line " ed1.Line " in |" ed1.What "|:`n" ed1.Message "`n", 0)
        ExitApp           
    }
}
;==========================================================================================

